config/routes.rb
Rails.application.routes.draw do
  root "posts#index"
  devise_for :users,
             path: "",
             path_names: { sign_in: "login", sign_out: "logout", edit: "profile", sign_up: "registration" },
             controllers: { omniauth_callbacks: "omniauth_callbacks" }
  #get "users/:id", to: "users#show"
  resources :users, only: [:index, :show, :sear]
  #get "users/:term", to: "users#index"
  resources :posts, only: [:index, :create, :show, :destroy] do
    resources :likes, only: [:create, :destroy, :index, :show, :new, :edit, :update], shallow: true
    resources :comments, only: [:index, :create, :destroy]
  end
  #get "posts/show", to: "posts#show"
  #root "posts#show"
  get "/featured", to: "featured#show"
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/comment.rb
class Comment < ApplicationRecord
  belongs_to :post
  belongs_to :user
end

app/models/like.rb
class Like < ApplicationRecord
  belongs_to :post
  belongs_to :user

  validates :user_id, uniqueness: { scope: :post_id }
  
end

app/models/photo.rb
class Photo < ApplicationRecord
  belongs_to :post

  validates :image, presence: true
  mount_uploader :image, PhotoUploader
end

app/models/post.rb
class Post < ApplicationRecord
  belongs_to :user
  has_many :photos, dependent: :destroy
  has_many :likes, dependent: :destroy
  has_many :comments, dependent: :destroy

  def is_liked(users)
    Like.find_by(user_id: user.id, post_id: id)
  end
end

app/models/user.rb
class User < ApplicationRecord
  has_many :posts, dependent: :destroy
  has_many :likes
  has_many :comments
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable,
         :omniauthable, omniauth_providers: %i[facebook]
  validates :name, presence: true, length: { minimum: 3, maximum: 13 }

  def self.from_omniauth(auth)
    where(provider: auth.provider, uid: auth.uid).first_or_create do |user|
      user.email = auth.info.email
      user.password = Devise.friendly_token[0, 20]
      user.name = auth.info.name   # assuming the user model has a name
      user.image = auth.info.image # assuming the user model has an image
      user.uid = auth.uid
      user.provider = auth.provider
      # If you are using confirmable and the provider(s) you use validate emails,
      # uncomment the line below to skip the confirmation emails.
      # user.skip_confirmation!
    end
  end

end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  before_action :configure_permitted_params, if: :devise_controller?

  protected

  def configure_permitted_params
    devise_parameter_sanitizer.permit(:sign_up, keys: [:name])
    devise_parameter_sanitizer.permit(:account_update, keys: [:name])
  end
end

app/controllers/comments_controller.rb
class CommentsController < ApplicationController
  before_action :authenticate_user!

  def index
    #@post = Post.last
    #@comments = @post.comments.all
    @comments = @post.comments.includes(:user)
  end

  def create
    @comment = Comment.new (comment_params)
    if @comment.save
      @post == @comment.post
      respond_to :js
    else
      flash[:notice] = "Something Went Wrong"
    end
  end

  def destroy
    @comment = Comment.find(params[:id])
    #@post = @comment.post
    if @comment.destroy
      respond_to :js

    else
      flash[:notice] = "something went wrong "
    end
  end

  private

  def comment_params
    params.required(:comment).permit(:user_id, :post_id, :content)
  end
end

app/controllers/featured_controller.rb
class FeaturedController < ApplicationController
  def show
    @featured = Post.where(featured: true)
  end
end

app/controllers/likes_controller.rb
class LikesController < ApplicationController
  before_action :authenticate_user!

  def create
    @like = current_user.likes.build(like_params)
    @post = @like.post
    if @like.save
      respond_to :js
    else
      flash[:notice] = "something went wrong "
    end
  end

  def destroy
    @like = Like.find(params[:id])
    @post = @like.post
    if @like.destroy
      respond_to :js
    else
      flash[:notice] = "Something went wrong "
    end
  end

  private

  def like_params
    params.permit :post_id
  end
end

app/controllers/omniauth_callbacks_controller.rb
class OmniauthCallbacksController < Devise::OmniauthCallbacksController
  # See https://github.com/omniauth/omniauth/wiki/FAQ#rails-session-is-clobbered-after-callback-on-developer-strategy
  skip_before_action :verify_authenticity_token, only: :facebook

  def facebook
    # You need to implement the method below in your model (e.g. app/models/user.rb)
    @user = User.from_omniauth(request.env["omniauth.auth"])

    if @user.persisted?
      sign_in_and_redirect @user, event: :authentication #this will throw if @user is not activated
      set_flash_message(:notice, :success, kind: "Facebook") if is_navigational_format?
    else
      session["devise.facebook_data"] = request.env["omniauth.auth"].except(:extra) # Removing extra as it can overflow some session stores
      redirect_to new_user_registration_url
    end
  end

  def failure
    flash[:notice] = "Failed to authenticate"
  end
end

app/controllers/pages_controller.rb
class PagesController < ApplicationController
  def home
    # if !user_signed_in?
    #   redirect_to new_user_session_path
    # end
  end
end

app/controllers/posts_controller.rb
class PostsController < ApplicationController
  before_action :authenticate_user!
  before_action :find_post, only: [:show]

  def index
    @posts = Post.all.includes(:photos, :user, :likes).order(created_at: :desc)
  end

  def new
    @post = Post.new
  end

  def create
    @post = current_user.posts.build(content: params[:post][:content])
=begin
    if @post.save
      redirect_to posts_path, notice: "Succesfully uploaded"
    else
      render "new"
    end
=end
    if @post.save
      puts "saved "

      @post.photos.create(image: params[:post][:image])
      #puts params[:post][:images]
      #params[:images].each do |img|
      #  @post.photos.create(image: img)
      #  puts "This is", params[:images]
      flash[:notice] = "saved"
      redirect_to posts_path
      #end
      #end
    else
      flash[:alert] = "Something went wrong "
      redirect_to posts_path
    end
  end

  def destroy
    @post = Post.find(params[:id])
    if @post.destroy
      flash[:notice] = "successfully deleted"
    else
      flash[:notice] = "something went wrong"
    end
    redirect_to posts_path
  end

  def show
    @posts = current_user.posts.includes(:photos, :user, :likes).order(created_at: :desc)
    #@comments = Comment.new
    #@likes = @post.likes.includes(:user)
    #@is_liked = @post.is_liked(current_user)
  end

  private

  def find_post
  end

  def post_params
    params.require(:post).permit(:content, :image)
  end
end

app/controllers/users_controller.rb
class UsersController < ApplicationController
  def index
    term = params[:term]
    @users = User.where("name like '%#{term}%'")
    respond_to :js
  end

  def show
    @user = User.find(params[:id])
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
  def avatar_url(user)
    if user.image
      return user.image
    else
      return "https://brighterwriting.com/wp-content/uploads/icon-user-default-420x420.png"
    end
  end
end

app/helpers/featured_helper.rb
module FeaturedHelper
end

app/helpers/pages_helper.rb
module PagesHelper
end

app/views/featured/show.html.erb
<% @featured.each do |featured_post| %>
  <%=featured_post.content%>
<% end %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Instagram</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>
    <%= stylesheet_link_tag "application", media: "all", 'data-turbolinks-track': "reload" %>
    <%= javascript_pack_tag "application", 'data-turbolinks-track': "reload" %>
  </head>
  <body>
    <header>
      <!--we can also use if current_user-->
      <%= render "shared/navbar" if user_signed_in?%>
    </header>
    <p class="notice"><%= notice %></p>
    <p class="alert"><%= alert %></p>
    <div class="container">
      <%= yield %>
    </div>
    <%= render "shared/footer"%>
    <script src="https://code.jquery.com/jquery-3.2.1.slim.min.js" integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>
  </body>
</html>

app/views/likes/create.js.erb
$("#like-post-icon-<%=@post.id.to_s%>").
html('<%= link_to "Love", like_path(@like), method: :delete, remote: true, class: "core-sprite loved hide-text"%>');

app/views/likes/destroy.js.erb
$("#like-post-icon-<%@post.id.to_s%>"").
html('<%= link_to "Loved", post_likes_path(@post), method: :post, remote: true, class: "core-sprite love hide-text"%>');

app/views/posts/index.html.erb
<div class="d-flex flex-column align-items-center mt-3">
  <div class="post-card">
    <!--col-xl-7 col-lg-8 col-md-10 col-sm-11-->
    <div class="card">
      <div class="card-header">
        Create Post 
      </div>
      <div class="card-body">
        <%=form_with model: Post do |form| %>
          <div class= "form-group row mt-2">
            <div class= "col-auto pr-0">
              <%=image_tag avatar_url(current_user), class:"post-author-icon "%>
            </div>
            <div class="col pl-0">
              <%=form.text_field :content, class: "form-control", placeholder: "Say Something about it.." %>
            </div>
          </div>
          <div class="fallback">
            <%=form.file_field :image, mulitple: true %>
          </div>
          <br>
          <%=form.submit "Post", class: "btn btn-primary"%>
        <% end %>
      </div>
    </div>
    <div class="card-header">
      <h3>My Posts</h3>
    </div>
    <div class="card">
      <%= render 'shared/posts' %>
      <div>
      </div>
    </div>

app/views/posts/show.html.erb
<div class="d-flex flex-column align-items-center mt-3">
  <div class="post-card">
    <div class="card">
      <%= render 'shared/posts'%>
    </div>
  </div>
</div>

app/views/shared/_footer.html.erb
<nav class="navbar navbar-expand-lg navbar-light bg-light">
  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar">
    <span class="navbar-toggler-icon"></span>
  </button>
  <div class="collapse navbar-collapse" id="navbar">
    <div class="navbar-nav mx-auto">
      <a href="" class="nav-item nav-itemf nav-link" href="#">ABOUT</a>
      <a href="" class="nav-item nav-itemf nav-link" href="#">Blog</a>
      <a href="" class="nav-item nav-itemf nav-link" href="#">Jobs</a>
      <a href="" class="nav-item nav-itemf nav-link" href="#">Help</a>
      <a href="" class="nav-item nav-itemf nav-link" href="#">API</a>
      <a href="" class="nav-item nav-itemf nav-link" href="#">Privacy</a>
      <a href="" class="nav-item nav-itemf nav-link" href="#">Terms</a>
      <a href="" class="nav-item nav-itemf nav-link" href="#">Top Accounts</a>
      <a href="" class="nav-item nav-itemf nav-link" href="#">Hashtags</a>
      <a href="" class="nav-item nav-itemf nav-link" href="#">Locations</a>
    </div>
  </div>
</nav>

app/views/shared/_navbar.html.erb
<nav class="navbar navbar-expand-lg navbar-light">
  <div class="container">
    <%= link_to "Icon", root_path, class: "navbar-brand core-sprite hide-text"%>
    <div class="collapse navbar-collapse" id="navbarSupportedContent">
      <%= form_with url: "users/", method: :get,class: "form-inline my-2 my-lg-0 ml-md-auto", id: "users-search" do |form| %>
        <%= form.text_field :term, class: "form-control mr-sm-2 text-center",placeholder: "search"   %>
        <div id="users-result">
        </div>
        <!--
        <form class="form-inline my-2 my-lg-0 ml-md-auto">
        <input class="form-control mr-sm-2 text-center" type="search" placeholder="Search" aria-label="Search">
      </form> -->
      <% end %>
      <ul class="navbar-nav ml-md-auto">
        <li class="nav-item">
          <% if user_signed_in? %>
            <%= link_to "logout", destroy_user_session_path, method: :delete %>
          <% end %>
        </li>
        <li class="nav-item">
          <a class="nav-link core-sprite explore-icon hide-text" href="#">explore</a>
        </li>
        <li class="nav-item">
          <a class="nav-link core-sprite notification-icon hide-text" href="#">notification</a>
        </li>
        <li class="nav-item">
          <%= link_to "profile", user_path(current_user), class: "nav-link core-sprite profile-icon hide-text"%>
        </li>
      </ul>
    </div>
  </div>
</nav>

app/views/shared/_posts.html.erb
<%@posts.each do |post|%>
  <div class ="card-header">
    <%= link_to user_path(post.user), class: "no-text-decoration" do %>
      <%= image_tag avatar_url(post.user), class: "post-author-icon"%>
      <% if current_user == post.user %>
        <%= link_to "delete", post_path(post.id), method: :delete, remote: true%>
      <% end %>
    <% end %>
    <%= link_to user_path(post.user), class: "normal-color no-text-decoration",title: post.user.name do %>
      <strong><%= post.user.name%></strong>
    <% end %>
  </div>
  <div class="card-body">
    <br>
    <%post.photos.each do |i| %>
      <img src=<%= i.image%> alt="Post.content" width="550" height="350">
    <% end %>
    <br>
    <div class="row actions">
      <div id = "like-icon-post-<%post.id.to_s%>" >
        <%if post.is_liked(current_user).present?%>
          <%= link_to "Love", like_path(post.is_liked(current_user)),method: :delete, remote: true, class: "core-sprite loved hide-text" %>
        <%else%>
          <%= link_to "loved", post_likes_path(post), method: :post, remote: true, class: "core-sprite love hide-text"%>
        <%end%>
      </div>
    </div>
    <div id="like-text-post-<% post.id.to_s%>">
      <strong><% post.likes.each.with_index do|like, index| %>
          <% if post.likes.size==1 %>
            <%= like.user.name%> Likes this <br>
          <% elsif like ==  post.likes.last %>
            <%= like.user.name%> Like this   <br>
          <% elsif index >1  %>
            <%="and" + (post.likes.size-index).to_s+ "others"%> like this <br>
            <%break%>
          <% elsif index==post.likes.size-2 || index==1 %>
            <%= like.user.name%> <br>
          <% else %>
            <%=like.user.name +","%>
          <% end %>
        <% end %>
      </strong>
      <span><strong><%= post.user.name%></strong></span>
      <span><%= post.content%></span>
    </div>
    <div class="light-color post-time"><%= time_ago_in_words(post.created_at).capitalize%> ago</div>
    <hr>
    <div class="comment-post">
      <% post.comments.each do |comment|%>
        <strong><%=comment.user.name%></strong>
        <%= comment.content%>
        <% if current_user == comment.user %>
          <%= link_to "delete", post_comment_path(post, comment), method: :delete, remote: true%>
        <% end %>
        <br>
      <% end %>
    </div>
    <div class="row actions">
      <%=form_with model: [Post, Comment], class: "w-100" do |form| %>
        <div class= "form-group row mt-2">
          <div class= "col-auto pr-0">
            <%=image_tag avatar_url(current_user), class:"post-author-icon "%>
          </div>
          <div class="col pl-0">
            <%=form.hidden_field :user_id, value: current_user.id%>
            <%=form.hidden_field :post_id, value: post.id%>
            <%=form.text_field :content, class: "form-control", placeholder: "Say Something about it.." %>
          </div>
        </div>
        <%=form.submit "Comment", class: "btn btn-xs btn-primary"%>
      <% end %>
    </div>
  </div>
<% end %>

app/views/users/_users_result.html.erb
<% if users.present? %>
  <%users.each do |user|%>
    <%= link_to user_path(user), class: "no-text-decoration" do %>
      <div class="search-result-item"><%= user.name%></div>
    <% end %>
  <% end %>
<% else %>
  <div class="p-3">
    No results found
  </div>
<% end %>

app/views/users/index.html.erb
<% if users.present? %>
  <%users.each do |user|%>
    <% link_to user_path(user), class: "no-text-decoration" do %>
      <div class="search-result-item"><%= user.name%></div>
    <% end %>
  <% end %>
<% else %>
  <div class="p-3">
    No results foun
  </div>
<% end %>

app/views/users/index.js.erb
$("#users-result").html('<%= j render "users_result", {users: @users}%>')

app/views/users/show.html.erb
<div class="row justify-content-md-center profile-wrapper">
  <div class="col-md-4 text-center">
    <%= image_tag avatar_url(@user), width: "152", height: "152", class: "round-img" %>
  </div>
  <div class="col-md-8">
    <div class="row">
      <p class="username"><%= @user.name %></p>
      <div class="row">
        <p class="email"><%= @user.email %></p>
      </div>
      <button class="btn btn-outline-dark common-btn edit-profile-btn">Edit Profile</button>
      <!-- Button trigger modal -->
      <button type="button" class="core-sprite setting" data-toggle="modal" data-target="#exampleModal"></button>
      <!-- Modal -->
      <div class="modal fade" id="exampleModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
        <div class="modal-dialog" role="document">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="exampleModalLabel">Settings</h5>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <div class="list-group text-center">
              <%= link_to "Change Password", edit_user_registration_path, class: "list-group-item list-group-item-action"%>
              <%= link_to "logout", destroy_user_session_path, method: :delete, class:"list-group-item list-group-item-action"  %>
              <a href="#" class="list-group-item list-group-item-action" data-dismiss="modal">Cancel</a>
            </div>
          </div>
        </div>
        <div class="row">
          <p class="email"><%= @user.email %></p>
        </div>
      </div>
    </div>
  </div>